precision highp float;

#define PI 3.1415926538

uniform highp mat4 mvp;

in highp vec4  inPosition;
in highp float  inHopLineFract;
uniform float  inBuildInFract;
uniform float  inPhase;
uniform float  inDist;
uniform float  inBackingScaleFactor;
out float ptsz;

void main (void)
{
	gl_Position	= mvp * inPosition;
	
	float hopLineFract = inHopLineFract;
	float buildInFract = inBuildInFract * 1.3;
	
	float rads = (hopLineFract * 60. * inDist) + (-inPhase * PI);
	float sinusoid = sin(rads);
	
	float bsf = max(1.0, inBackingScaleFactor);
	
	float fractShifted = hopLineFract - buildInFract;
	fractShifted = max(fractShifted, -(1.5707963 / 3.));
	float fractCurved = 1.0 + (sin(3.*fractShifted));
	fractCurved = clamp(fractCurved, .35, 1.0);
	
	fractCurved += 0.05 + (0.09 * sinusoid);
	
	fractCurved *= 1.0 - step(0.01,fractShifted);
	
	ptsz = 19. * bsf * fractCurved;
	ptsz += inPhase * 0.01;
	//ptsz = buildInFract * 10.0;
	//ptsz *= sinusoid;
	
	
	gl_PointSize = ptsz;
}
